//////////////////////////////////////////////////////////////////////////////
// Program Name: upnpcdsmusicalbum.h
//
// Purpose - uPnp Content Directory Extension for Music Albums
//
// Created By  : Joe Bryant                     Created On : Jul. 29, 2011
// Modified By :                                Modified On:
//
//////////////////////////////////////////////////////////////////////////////

#ifndef UPnpCDSMusicAlbum_H_
#define UPnpCDSMusicAlbum_H_

#include <QString>

#include "upnpcds.h"

//////////////////////////////////////////////////////////////////////////////
//
//////////////////////////////////////////////////////////////////////////////
class MSqlQuery;
class UPnpCDSMusicAlbum : public UPnpCDSExtension
{
    private:

        static UPnpCDSRootInfo g_RootNodes[];
        static int             g_nRootCount;

    protected:

        virtual UPnpCDSRootInfo *GetRootInfo   (int nIdx, QString sContainerId = "");
        virtual int              GetRootCount  ( );
        virtual QString          GetTableName  ( QString sColumn );
        virtual QString          GetItemListSQL( QString sColumn = "" );

        virtual void             BuildItemQuery( MSqlQuery        &query,
                                                 const QStringMap &mapParams );

        virtual void             AddItem( const UPnpCDSRequest    *pRequest, 
                                          const QString           &sObjectId,
                                          UPnpCDSExtensionResults *pResults,
                                          bool                     bAddRef,
                                          MSqlQuery               &query );
    public:

        UPnpCDSMusicAlbum( ) : UPnpCDSExtension( "Music", "Music",
                                            "object.container.album.musicAlbum" )
        {
        }

        virtual ~UPnpCDSMusicAlbum() {}
};

#endif
